#include "Balls.h"

static long Ticker(void *data)
{
	BallsView *the_view=(BallsView *)data;
	double start_time;
	
	while(1)
	{
		start_time=the_view->start_time=system_time();
		
#ifdef LOCKOUTSIDE
		bool attached=the_view->Window()->Lock();
#endif

		the_view->Tick();
		
#ifdef LOCKOUTSIDE
		if (attached) the_view->Window()->Unlock();
#endif

//		printf("update time : %fus\n",system_time()-start_time);

		the_view->last_frame = system_time()-start_time;

		snooze(start_time+frame-system_time());
	}
	
	return 0;	
}

BallsView::BallsView(BRect frame)
//PC/*
: BView(frame,NULL,B_FOLLOW_ALL,B_WILL_DRAW|B_FRAME_EVENTS),
//PC*/
  back(true), bench(false), n_visible(0), 
  last_frame(0), start_time(0), last_calc(0)
{
	SetViewColor(B_TRANSPARENT_32_BIT);
	
	fBounds=Bounds();
	
	the_sprite = new PixelSprite;
	the_sprite->width=16;
	the_sprite->height=16;
	
	// let's load
	app_info myinfo;
	
	be_app->GetAppInfo(&myinfo);
	
	BResourceFile *rfile;
	
	rfile=new BResourceFile(myinfo.ref);
	
	rfile->Open(B_READ_ONLY);
	
	long datalength;
	
	the_sprite->data =
		(uchar *)rfile->FindResource('RAW8',"Ball",&datalength);
		
	delete rfile;
	// done loading
		
	the_bitmap =
		new PixelBitmap(frame);
		
	the_bitmap->Clear(0);
	
}


#ifdef HOLES

// starts a "transaction" of Adds
// not yet implemented
void BallsView::BeginTrans()
{
	first_in_trans=INT_MAX;
	last_in_trans=-1;
}

void BallsView::Commit()
{
}

void BallsView::AddBalls(int howmany)
{
/*	int new_n_balls=n_balls+howmany;
	
	if (new_n_balls>n_balls_max) new_n_balls=n_balls_max;
	
	int i=first_unused;
	while(n_balls<new_n_balls)
		balls;
*/
	for (int i=0;i<howmany && n_balls<n_balls_max;i++)
		AddBall(); // not initialized !
}

// adds a ball, returns the index or -1 on error
int BallsView::AddBall()
{	
	if (n_balls>=n_balls_max) return -1;
	
	n_balls++;
	
	int result=first_unused;
	
	balls[result].used=true;
#pragma warn_possunwant off	
	if (balls[result].use_delayed=trans)
	{
		if (result<first_in_trans) first_in_trans=result;
		if (result>last_in_trans) last_in_trans=result;
	}
	
	if (result<first_used) first_used=result;
	if (result>last_used) last_used=result;
	
	if (n_balls==n_balls_max)
		first_unused=INT_MAX;
	else // at least one is free
	{
		int i=first_unused;
		while (ASSERT(i<=n_balls_max),balls[i].used) i++;
		first_unused=i;
	}
	
	return result;	
		
}

// removes the "howmany" last balls
void BallsView::RemoveBalls(int howmany)
{
	if (howmany==0 || n_balls==0) return;
	
//	for (int i=0;i<howmany && n_balls>0;i++)
//		RemoveBall();
		
	if (howmany>=n_balls) // j'enlve tout !
	{
		n_balls=0;
		for (int i=first_used;i<=last_used;i++)
		{
			balls[i].used=false; // normalement superflu...
		}
		first_used=INT_MAX;
		last_used=-1;
		first_unused=0;
		return;
	}
		
	// we're removing at least one, and leaving at least one
	n_balls-=howmany;
	
	ASSERT(first_used>=0);
	ASSERT(last_used>0);
	
	int i=last_used;
	while (i>=first_used && howmany>0)
	{
		if (balls[i].used)
		{
			balls[i].used=false;
			howmany--;
		}
		i--;
	}
	while (i>=first_used && !balls[i].used) ASSERT(i>0),i--;
	last_used=i;
	if (first_unused>i+1) first_unused=i+1;
	
}

// removes a ball (the last)
void BallsView::RemoveBall()
{
//	RemoveBall(last_used); // this would do it too

	if (n_balls==0) return;
	
	if (--n_balls==0)
	{
		first_used=INT_MAX;
		last_used=-1;
		first_unused=0;
		return;
	}
	
	// at least one other ball left
	
	balls[last_used].used=false;
	
	if (last_used<first_unused)
		first_unused=last_used;
	
	int i=last_used-1;
	while (i>first_used && !balls[i].used) i--;
	last_used=i;
	
}

// removes the ball at index
void BallsView::RemoveBall(int index)
{
	if (!balls[index].used || n_balls==0) return;
	
	balls[index].used=false;
	
	if (--n_balls==0)
	{
		first_used=INT_MAX;
		last_used=-1;
		first_unused=0;
		return;
	}
	
	// we're sure at least one other ball is left
	
	if (index==first_used)
	{
		int i=first_used+1;
		while (i<last_used && !balls[i].used) i++;
		first_used=i;
	}
	else if (index==last_used) // since it wasn't the last ball
							   // we removed, first!=last
 	{
		int i=last_used-1;
		while (i>first_used && !balls[i].used) i--;
		last_used=i;
	}
	
	if (index<first_unused) first_unused=index;
	
}

#endif // HOLES

void BallsView::AttachedToWindow()
{

#ifdef HOLES
	n_balls=0;
	first_used=INT_MAX;
	last_used=-1;
	first_unused=0;
	for (int i=0;i<n_balls_max;i++)
	{
		balls[i].used=false;	
	}
	
	trans=false;

	for(int j,i=0;i<10;i++)
	{
		if ((j=AddBall())!=-1)
		{
			Ball &ball=balls[j];
			ball.pos.Set(rand()%200,rand()%200);
			ball.ix=rand()%7-3;
			ball.iy=rand()%7-3;
			ball.target=-1;
		}
	}
#else // HOLES

	n_balls=5;
	for(int i=0;i<n_balls;i++)
	{
		Ball &ball=balls[i];
		ball.pos.Set(rand()%200,rand()%200);
# ifdef SCREEN
		ball.pos+=fScreenFrame.LeftTop();
# endif
		ball.ix=rand()%7-3;
		ball.iy=rand()%7-3;
		ball.target=-1;
	}
#endif // HOLES
	
	RefreshTitle();
	
	MakeFocus();
	
	Ticker_id = spawn_thread(Ticker,"ticker",B_NORMAL_PRIORITY,this);
	resume_thread(Ticker_id);
}

void BallsView::FrameResized(float w,float h)
{
#pragma unused(w,h)
	fBounds=Bounds();
#ifdef SCREEN
	WindowMoved();
#endif
}

void BallsView::DetachedFromWindow()
{
	kill_thread(Ticker_id); 
}

BallsView::~BallsView()
{
	delete the_sprite->data;
	delete the_sprite;
	delete the_bitmap;
}

void BallsView::Tick()
{	
	if (back)
	{
//		the_bitmap->Clear(index_for_color(255,0,0));
//		the_bitmap->Box(the_bitmap->Bounds(),index_for_color(255,0,0));
//		the_bitmap->Box(0,0,the_bitmap->Bounds().right,100,
//			index_for_color(0,255,0));		
		for (int y=0;y<=fBounds.bottom;y++)
		{
			the_bitmap->Box(0,y,the_bitmap->Bounds().right,y,
				index_for_color(0,0,(255*y)/fBounds.bottom));
		}
		the_bitmap->Box(0,fBounds.bottom+1,the_bitmap->Bounds().right,
			the_bitmap->Bounds().bottom,index_for_color(0,0,255));
	}
	else
		the_bitmap->Clear(0);

//	printf("blittime=%f\n",last_frame-last_calc);	

	if (bench)
	{
		int limit_blit =
			fBounds.right*(last_frame-last_calc)/::frame/2;
			
		int limit_frame =
			fBounds.right*last_frame/::frame/2;
	
		the_bitmap->Box(0,0,limit_blit,10,32);
			
		if (last_frame<=::frame) 
			the_bitmap->Box(limit_blit,0,limit_frame,10,52);
		else
			if (last_frame-last_calc<::frame) 
				the_bitmap->Box(limit_blit,0,limit_frame,10,42);
			else // blit plus longer than frame
				the_bitmap->Box(limit_blit,0,limit_frame,10,42);
	}
			
	int new_n_visible=0;
	
#ifdef HOLES
	ASSERT(n_balls==0 || (n_balls>0 && n_balls<=last_used-first_used+1));
#endif
	
	FOR_EACH_BALL(i)
	{
//		the_bitmap->SetPixel(1,i,255);
	
		Ball &ball=balls[i];
		
		BPoint &pos=ball.pos;
		
		float &ix=ball.ix, &iy=ball.iy;
		
		pos.x+=ix;
		pos.y+=iy;
		
#ifdef SCREEN
		if (pos.x<fScreenFrame.left+8) 
		{pos.x=fScreenFrame.left+8;ix=-ix;}
		//if (pos.y<10) {pos.y=10;iy=-iy;}
		if (pos.x>fScreenFrame.right-8) {pos.x=fScreenFrame.right-8;ix*=-1;};
		if (pos.y>fScreenFrame.bottom-8) {pos.y=fScreenFrame.bottom-8;iy*=-1;};
#else
		if (pos.x<8) {pos.x=8;ix=-ix;}
		//if (pos.y<10) {pos.y=10;iy=-iy;}
		if (pos.x>fBounds.right-8) {pos.x=fBounds.right-8;ix*=-1;};
		if (pos.y>fBounds.bottom-8) {pos.y=fBounds.bottom-8;iy*=-1;};		
#endif	
	
		//ix*=0.999;
/*		if (iy>0) iy*=1.1; else iy*=0.9;
		if (iy<0 && iy>-0.2) iy=-0.21;*/

		iy+=0.2;
#ifdef SCREEN
		if (pos.y>=fScreenFrame.top+8) 
		{
			the_bitmap->PutSprite(the_sprite,
				pos-BPoint(8,8)-fScreenFrame.LeftTop());
#else
		if (pos.y>=8) 
		{
			the_bitmap->PutSprite(the_sprite,pos-BPoint(8,8));
#endif			
			new_n_visible++;
		}		
	}
	
	last_calc=system_time()-start_time;
	
#ifndef LOCKOUTSIDE
	if(Window()->Lock())
	{
#endif		

#ifndef RELEASE		
		if (new_n_visible!=n_visible)
		{
			n_visible=new_n_visible;
			RefreshTitle();
		}
#endif
	
		Draw(fBounds);
	
#ifndef LOCKOUTSIDE
		Window()->Unlock();
	}
#endif		

	
}

void BallsView::Draw(BRect update)
{
	DrawBitmap/*Async*/(the_bitmap,update,update);
}

/*PC

void BallsView::DrawBitmap(PixelBitmap *bitmap,BRect source,BRect dest)
{
	sync();
	blit(bitmap->bitmap,screen,source.left,source.top,
		dest.left,dest.top,source.Width(),source.Height());
}

PC*/

void BallsView::KeyDown(ulong achar)
{
	int new_n_balls;
	
	switch(achar)
	{
		case '+':
#ifndef HOLES
			new_n_balls=n_balls+5;
			if (new_n_balls>n_balls_max) new_n_balls=n_balls_max;
			for (int i=n_balls;i<new_n_balls;i++)
			{
				balls[i].pos.Set(rand()%200,rand()%200);
				balls[i].ix=rand()%7-3;
				balls[i].iy=rand()%7-3;
			}
			n_balls=new_n_balls;		
#else
			for(int j,i=0;i<5;i++)
			{
				if ((j=AddBall())!=-1)
				{
					Ball &ball=balls[j];
					ball.pos.Set(rand()%200,rand()%200);
					ball.ix=rand()%7-3;
					ball.iy=rand()%7-3;
					ball.target=-1;
				}
			}		
#endif
			RefreshTitle();
			break;

		case '-':
#ifndef HOLES
			new_n_balls=n_balls-5;
			if (new_n_balls<0) new_n_balls=0;
			n_balls=new_n_balls;
			
			for (int i=0;i<n_balls;i++)
				if (balls[i].target>=n_balls) 
					balls[i].target=-1;
					
#else
			for (int i=0;i<5;i++)
				RemoveBall(first_used);

//			RemoveBalls(5);
#endif

			RefreshTitle();
			break;

		case '*':
			FOR_EACH_BALL(i)
			{
				balls[i].ix*=1.5;
				balls[i].iy*=1.5;
			}
			break;
		case '/':
			FOR_EACH_BALL(i)
			{
				balls[i].ix/=1.5;
				balls[i].iy/=1.5;
			}
			break;
		case B_ENTER:
			float alpha,spd;
			FOR_EACH_BALL(i)
			{
				alpha=int(16*2*PI*(rand()/(float)RAND_MAX))/16.0;
				spd=rand()%5;
				balls[i].ix=spd*cos(alpha);
				balls[i].iy=spd*sin(alpha);
			}
			break;
/*		case 'd':
		case 'D':
			new_n_balls=2*n_balls;
			if (new_n_balls>n_balls_max) new_n_balls=n_balls_max;
			for (int i=n_balls;i<new_n_balls;i++)

			new_n_balls=n_balls;
			int j;
			FOR_EACH_BALL(i)
			for (int j,i=0;i<new_n_balls;i++)
			{	
				if ((j=AddBall())!=-1)
				{
					float tmp=balls[i-n_balls].ix;
					balls[i-n_balls].ix=-balls[i-n_balls].iy/4;
					balls[i-n_balls].iy=tmp/4;
					
					// new ball
					balls[i].ix=-balls[i-n_balls].ix;
					balls[i].iy=-balls[i-n_balls].iy;
					
					balls[i].pos=balls[i-n_balls].pos;
				}
			}
			n_balls=new_n_balls;
			break;
		case 'f':
		case 'F':
			for (int i=1;i<n_balls;i+=2)
			{
				balls[i-1].target=i;
				balls[i].target=i-1;
			}
*/
		case 'b':
		case 'B':
			back=!back;
			break;			
		case 's':
		case 'S':
			bench=!bench;
			break;			
	}
}

void BallsView::MouseDown(BPoint point)
{
	ulong buttons=
		Window()->CurrentMessage()->FindLong("buttons");

	if (buttons & B_PRIMARY_MOUSE_BUTTON)
	{
/*		for (int i=0;i<n_balls;i++)
		{
			balls[i].ix+=
				3*(balls[i].pos.x>point.x?1:-1)*
				(1-fabs((balls[i].pos.x-point.x)/fBounds.Width()));
			balls[i].iy+=
				3*(balls[i].pos.y>point.y?1:-1)*
				(1-fabs((balls[i].pos.y-point.y)/fBounds.Height()));
		}
*/
		FOR_EACH_BALL(i) if (i&1)
		{
			balls[i].ix=-
				5*(balls[i].pos.x>point.x?1:-1)*
				(fabs((balls[i].pos.x-point.x)/200));//fBounds.Width()));
			balls[i].iy=-
				5*(balls[i].pos.y>point.y?1:-1)*
				(fabs((balls[i].pos.y-point.y)/200));//fBounds.Height()));
		}
	
	} else
	{
		FOR_EACH_BALL(i) if (!(i&1))
		{
			balls[i].ix=-
				5*(balls[i].pos.x>point.x?1:-1)*
				(fabs((balls[i].pos.x-point.x)/200));//fBounds.Width()));
			balls[i].iy=-
				5*(balls[i].pos.y>point.y?1:-1)*
				(fabs((balls[i].pos.y-point.y)/200));//fBounds.Height()));
		}
	}
}

void BallsView::RefreshTitle()
{
	char s[1000];
	
#ifndef RELEASE
# ifdef HOLES
	sprintf(s,"%d balls (%d..%d) - %d visible",
		n_balls,first_used,last_used,n_visible);
# else
	sprintf(s,"%d balls - %d visible",
		n_balls,n_visible);
# endif
#else

	sprintf(s,"%d balls",n_balls);
	
#endif
	
	Window()->SetTitle(s);
}

#ifdef SCREEN
void BallsView::WindowMoved()
{
	fScreenFrame=ConvertToScreen(fBounds);
}
#endif

#ifdef EATKEYS
#pragma warn_possunwant off
void BallsView::MessageReceived(BMessage *message)
{
	switch(message->what)
	{
		B_KEY_DOWN:	
			// just keep the oldest one
			BMessage	*next;
			while (next = Looper()->MessageQueue()->FindMessage(B_KEY_DOWN, 0)) 
			{
				Looper()->MessageQueue()->RemoveMessage(next);
				printf("ignore : %d\n",next->FindLong("char"));
				delete next;
			}
			inherited::MessageReceived(message);
			break;			
		default:
			inherited::MessageReceived(message);
	}
}
#endif