#include "PixelBitmap.h"

PixelBitmap::PixelBitmap(BRect bounds)
//PC/*
: BBitmap(bounds,B_COLOR_8_BIT)
//PC*/
{
//PC	bitmap=create_bitmap(bounds.Width(),bounds.Height());
  fBits=(uchar *)Bits();
  fBpr=BytesPerRow();
}

/*PC

PixelBitmap::~PixelBitmap()
{
	destroy_bitmap(bitmap);
}

PC*/

void PixelBitmap::Box(BRect rect,uchar col)
{
	int y;
	uchar *offset;
	
	rect = rect & Bounds();
	
	offset=((uchar *)Bits())+int(rect.top)*BytesPerRow()+int(rect.left);
	for (y=0;y<=rect.IntegerHeight();y++)
	{
		memset(offset,col,rect.Width()+1);
		offset+=BytesPerRow();
	}

}

void PixelBitmap::Clear(uchar color)
{
	memset(Bits(),color,BitsLength());
}

void PixelBitmap::IncBox(int left,int top,int right,int bottom)
{
	int y,offset,end;
	uchar *bits = (uchar *)Bits();
	
	for (y=top;y<=bottom;y++)
		for (offset=y*BytesPerRow()+left,
			end=offset+right-left; offset<=end ; offset++)
			{bits[offset]++;}//bits[offset]&=0x1F;} // mod 32
}

void PixelBitmap::DecBox(int left,int top,int right,int bottom)
{
	int y,offset,end;
	uchar *bits = (uchar *)Bits();
	
	for (y=top;y<=bottom;y++)
		for (offset=y*BytesPerRow()+left,
			end=offset+right-left; offset<=end ; offset++)
			{bits[offset]--;bits[offset]&=0x1F;} // mod 32
}


#define BUF_SIZE 1000

#undef getc

// THIS BUFFERING IS AWFUL
// but then again, why isn't there buffering in libbe ?

//inline char getchr(BFile *file);

static char buf[BUF_SIZE];
static unsigned long bufptr=-1; // points to the next char

inline char getchr(BFile *file)
{
	if (bufptr>=BUF_SIZE)
	{
		file->Read(buf,BUF_SIZE);
		bufptr=0;
	};
	
	return buf[bufptr++];
}

PixelBitmap* PixelBitmap::FromPCX(char *filename)
{
	record_ref ref;
	
	get_ref_for_path(filename,&ref);

	return FromPCX(ref);

}

PixelBitmap* PixelBitmap::FromPCX(record_ref ref)
{
	int x,y;
	int i;
	int H,W;
	uchar b,cnt;
	uchar pal[256];
	uchar infos[4];
	PixelBitmap* result=NULL;
	double time=system_time();
	
	BFile *file = new BFile();
	
	file->SetRef(ref);
	
	if (   file->Size()>1024     // not too small
		&& file->Size()<1000000L // not too big
		&& file->Open(B_READ_ONLY) == B_READ_ONLY )
	{

		printf("File open !\n");

		file->Seek(8,B_SEEK_TOP);

		file->Read(infos,4);

		W=infos[1]*256+infos[0]+1;
		H=infos[3]*256+infos[2]+1;

		printf("W=%d,H=%d\n",W,H); 

		BRect bounds;

		bounds.Set(0,0,W-1,H-1);

		result =
			new PixelBitmap(bounds);

		file->Seek(-768,B_SEEK_BOTTOM);		

		uchar red,green,blue;

		for (i=0;i<=255;i++) {
			file->Read(&red,1);
			file->Read(&green,1);
			file->Read(&blue,1);
			
			pal[i]=index_for_color(red,green,blue,0);
			}
			
		file->Seek(128,B_SEEK_TOP);

		for (y=0;y<H;y++) {
			x=0;
			while (x<W) {
				b=getchr(file);
				if (b>192) 
				{
					cnt=b&63;
					b=getchr(file);
					i=x+cnt;
					while(x<i) 
					{
						result->SetPixel(x,y,pal[b]);
						x++;
					}
				}
				else 
				{
					result->SetPixel(x,y,pal[b]);
					x++;
				}
			}
		}

	}

	delete file; // this closes the file too
	
	//printf("buffer : %d, time : %f ms\n",BUF_SIZE,(system_time()-time)/1000);
		
	return result;
	
}

void PixelBitmap::PutSprite(PixelSprite *spr,int x,int y)
{
	register uint i;
	register uchar c;
	register uchar *source=spr->data;
	register uchar *dest;
	register uint delta;
	register uint w,h;
	register uint bpr=fBpr;	
		
	w=spr->width;
	h=spr->height;
	
	dest=fBits+y*bpr+x;
	delta=bpr-w;
	
	
#pragma warn_possunwant off // sometimes I know what I'm doing

	while(h)
	{
		for (i=0;i<w;i++)
		{
			if (c=*source++) *dest=c; // hurry up !
			dest++;
		}
		dest+=delta;
		h--;
	}
		
}